// ignore_for_file: non_constant_identifier_names
part of 'bmap_view.widget.dart';

/// marker点击事件回调签名 输入[Marker]对象, 返回`是否已消耗事件`, 如果true则不再弹窗, 如果false则继续弹窗
typedef Future<bool> OnMarkerClicked(Marker marker);

/// Marker拖动回调签名
typedef Future<void> OnMarkerDrag(Marker marker);

/// 地图移动事件回调签名
typedef Future<void> OnMapMove(MapMove move);

/// 地图控制类
class BmapController with WidgetsBindingObserver {
  /// Android构造器
  BmapController.android(this.androidController, this._state) {
    WidgetsBinding.instance.addObserver(this);
  }

  /// iOS构造器
  BmapController.ios(this.iosController, this._state) {
    WidgetsBinding.instance.addObserver(this);
  }

  com_baidu_mapapi_map_TextureMapView androidController;
  BMKMapView iosController;

  _BmapViewState _state;

  final _iosMapDelegate = _IOSMapDelegate();
  final _androidMapDelegate = _AndroidMapDelegate();

  /// 设置地图中心点
  ///
  /// [coordinate] 经纬度
  /// [animated] 是否动画
  Future<void> setCenterCoordinate(
    LatLng coordinate, {
    bool animated = true,
  }) async {
//    assert(
//      zoomLevel == null || (zoomLevel >= 3 && zoomLevel <= 19),
//      '缩放范围为3-19',
//    );
    final lat = coordinate.latitude;
    final lng = coordinate.longitude;
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置我的位置数据
  Future<void> showMyLocation(MyLocationOption option) async {
    final locationStream = BmapLocation.instance.listenLocation();

    final iconData = await option.iconProvider
        ?.toImageData(createLocalImageConfiguration(_state.context));

    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 批量添加marker
  ///
  /// 根据[options]批量创建Marker
  Future<List<Marker>> addMarkers(List<MarkerOption> options) async {
    assert(options != null);

    if (options.isEmpty) return Future.value([]);

    final latBatch = options.map((it) => it.latLng.latitude).toList();
    final lngBatch = options.map((it) => it.latLng.longitude).toList();
    final iconDataBatch = <Uint8List>[
      for (final option in options)
        if (option.iconUri != null && option.imageConfig != null)
          await uri2ImageData(option.imageConfig, option.iconUri)
        else if (option.widget != null)
          await _state.widgetToImageData(option.widget)
    ];
    final objectBatch = options.map((it) => it.object).toList();

    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置marker点击监听事件
  Future<void> setMarkerClickedListener(OnMarkerClicked onMarkerClicked) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 把marker列表从地图上移除
  Future<void> clearMarkers(List<Marker> markers) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 清除地图上所有覆盖物
  Future<void> clear() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 添加折线
  ///
  /// 可配置参数详见[PolylineOption]
  Future<Polyline> addPolyline(PolylineOption option) {
    assert(option != null);

    final latitudeBatch = option.latLngList.map((e) => e.latitude).toList();
    final longitudeBatch = option.latLngList.map((e) => e.longitude).toList();

    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 添加多边形
  ///
  /// 在点[points]的位置添加线, 可以设置宽度[width]和颜色[strokeColor]
  Future<Polygon> addPolygon(PolygonOption option) {
    assert(option != null, 'option不能为null');

    final latitudeBatch = option.latLngList.map((e) => e.latitude).toList();
    final longitudeBatch = option.latLngList.map((e) => e.longitude).toList();

    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 添加圆
  ///
  /// 在点[points]的位置添加线, 可以设置宽度[width]和颜色[strokeColor]
  Future<Circle> addCircle(CircleOption option) {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 放大一个等级
  Future<void> zoomIn() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 放大一个等级
  Future<void> zoomOut({bool animated = true}) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 选择显示图层
  Future<void> setMapType(MapType mapType) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 显示路况信息
  Future<void> showTraffic(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 缩放手势使能
  Future<void> setZoomGesturesEnabled(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 滑动手势使能
  Future<void> setScrollGesturesEnabled(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 旋转手势使能
  Future<void> setRotateGesturesEnabled(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 旋转手势使能
  Future<void> setOverlookingGesturesEnabled(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 所有手势使能
  Future<void> setAllGesturesEnabled(bool enable) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置缩放大小
  ///
  /// 地图的缩放级别一共分为 17 级，从 3 到 19. 数字越大，展示的图面信息越精细
  Future<void> setZoomLevel(double level) async {
    assert(level >= 3 && level <= 19, '缩放范围为3-19');
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 获取当前缩放大小
  Future<double> getZoomLevel() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置缩放是否以中心点为锚点
  Future<void> setZoomByCenter(bool byCenter) async {
    assert(byCenter != null);
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 获取地图中心点
  Future<LatLng> getCenterCoordinate() {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置marker拖动监听事件
  Future<void> setMarkerDragListener({
    OnMarkerDrag onMarkerDragStart,
    OnMarkerDrag onMarkerDragging,
    OnMarkerDrag onMarkerDragEnd,
  }) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置地图移动监听事件
  Future<void> setMapMoveListener({OnMapMove onMapMoveEnd}) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 释放资源
  Future<void> dispose() async {
    await androidController?.onPause();
    await androidController?.onDestroy();
    final map = await androidController?.getMap();
    await map.setMyLocationEnabled(false);

    await iosController?.viewWillDisappear();

    WidgetsBinding.instance.removeObserver(this);
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    debugPrint('didChangeAppLifecycleState: $state');
    // 因为这里的生命周期其实已经是App的生命周期了, 所以除了这里还需要在dispose里释放资源
    switch (state) {
      case AppLifecycleState.resumed:
        androidController?.onResume();
        iosController?.viewWillAppear();
        break;
      case AppLifecycleState.inactive:
        break;
      case AppLifecycleState.paused:
        androidController?.onPause();
        iosController?.viewWillDisappear();
        break;
      case AppLifecycleState.detached:
        androidController?.onDestroy();
        break;
    }
  }
}

class _IOSMapDelegate extends NSObject with BMKMapViewDelegate {
  OnMarkerClicked _onMarkerClicked;
  OnMarkerDrag _onMarkerDragStart;
  OnMarkerDrag _onMarkerDragging;
  OnMarkerDrag _onMarkerDragEnd;
  OnMapMove _onMapMoveEnd;

  BMKMapView _iosController;

  @override
  Future<void> mapView_clickAnnotationView(
    BMKMapView mapView,
    BMKAnnotationView view,
  ) async {
    super.mapView_clickAnnotationView(mapView, view);
    if (_onMarkerClicked != null) {
      await _onMarkerClicked(
        Marker.ios(
          BMKPointAnnotation()
            ..refId = (await view.get_annotation(viewChannel: false)).refId,
//          view,
          _iosController,
        ),
      );
    }
  }

  @override
  Future<void> mapView_annotationView_didChangeDragState_fromOldState(
    BMKMapView mapView,
    BMKAnnotationView view,
    int newState,
    int oldState,
  ) async {
    super.mapView_annotationView_didChangeDragState_fromOldState(
      mapView,
      view,
      newState,
      oldState,
    );
    if (_onMarkerDragStart != null && newState == 0) {
      await _onMarkerDragStart(
        Marker.ios(
          await view.get_annotation(viewChannel: false),
//          view,
          _iosController,
        ),
      );
    }

    if (_onMarkerDragging != null && newState == 1) {
      await _onMarkerDragging(
        Marker.ios(
          await view.get_annotation(viewChannel: false),
//          view,
          _iosController,
        ),
      );
    }

    if (_onMarkerDragEnd != null && newState == 2) {
      await _onMarkerDragEnd(
        Marker.ios(
          await view.get_annotation(viewChannel: false),
//          view,
          _iosController,
        ),
      );
    }
  }

  @override
  Future<void> mapStatusDidChanged(BMKMapView mapView) async {
    super.mapStatusDidChanged(mapView);
    if (_onMapMoveEnd != null) {
      final location = await mapView.get_centerCoordinate();
      await _onMapMoveEnd(MapMove(
        latLng: LatLng(await location.latitude, await location.longitude),
        zoom: await mapView.get_zoomLevel(),
        tilt: (await mapView.get_overlooking()).toDouble(),
      ));
    }
  }
}

class _AndroidMapDelegate extends java_lang_Object
    with
        com_baidu_mapapi_map_BaiduMap_OnMarkerClickListener,
        com_baidu_mapapi_map_BaiduMap_OnMarkerDragListener,
        com_baidu_mapapi_map_BaiduMap_OnMapStatusChangeListener {
  OnMarkerClicked _onMarkerClicked;
  OnMarkerDrag _onMarkerDragStart;
  OnMarkerDrag _onMarkerDragging;
  OnMarkerDrag _onMarkerDragEnd;
  OnMapMove _onMapMoveEnd;

  @override
  Future<bool> onMarkerClick(com_baidu_mapapi_map_Marker var1) async {
    super.onMarkerClick(var1);
    if (_onMarkerClicked != null) {
      await _onMarkerClicked(Marker.android(var1));
    }
    return true;
  }

  @override
  Future<void> onMarkerDragStart(com_baidu_mapapi_map_Marker var1) async {
    super.onMarkerDragStart(var1);
    if (_onMarkerDragStart != null) {
      await _onMarkerDragStart(Marker.android(var1));
    }
  }

  @override
  Future<void> onMarkerDrag(com_baidu_mapapi_map_Marker var1) async {
    super.onMarkerDrag(var1);
    if (_onMarkerDragging != null) {
      await _onMarkerDragging(Marker.android(var1));
    }
  }

  @override
  Future<void> onMarkerDragEnd(com_baidu_mapapi_map_Marker var1) async {
    super.onMarkerDragEnd(var1);
    if (_onMarkerDragEnd != null) {
      await _onMarkerDragEnd(Marker.android(var1));
    }
  }

  @override
  Future<void> onMapStatusChangeFinish(
    com_baidu_mapapi_map_MapStatus var1,
  ) async {
    super.onMapStatusChangeFinish(var1);
    if (_onMapMoveEnd != null) {
      final location = await var1.get_target();
      await _onMapMoveEnd(MapMove(
        latLng: LatLng(
          await location.get_latitude(),
          await location.get_longitude(),
        ),
        zoom: await var1.get_zoom(),
        tilt: await var1.get_overlook(),
      ));
    }
  }
}
