import 'dart:async';

import 'package:bmap_map_fluttify/src/android/android.export.g.dart';
import 'package:bmap_map_fluttify/src/ios/BMKLocationManager.g.dart';
import 'package:bmap_map_fluttify/src/ios/ios.export.g.dart';
import 'package:flutter/cupertino.dart';
import 'package:foundation_fluttify/foundation_fluttify.dart';

import 'enums.dart';
import 'models.dart';

class BmapLocation {
  static BmapLocation instance = BmapLocation._();

  BmapLocation._();

  com_baidu_location_LocationClient _androidClient;
  BMKLocationManager _iosClient;

  final _locationStream = StreamController<Location>();

  /// 初始化
  Future<void> init({@required String iosKey}) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 获取单次定位
  Future<Location> fetchLocation({
    LocationAccuracy mode = LocationAccuracy.Low,
    bool needAddress = true,
    Duration timeout,
  }) async {
    final location =
        listenLocation(mode: mode, needAddress: needAddress, timeout: timeout)
            .first;
    await stop();
    return location;
  }

  /// 连续获取定位信息
  ///
  /// 选择定位模式[mode], 设置定位同时是否需要返回地址描述[needAddress], 设置定位请求超时时间，默认为30秒[timeout]
  Stream<Location> listenLocation({
    LocationAccuracy mode = LocationAccuracy.Low,
    bool needAddress = true,
    Duration timeout = const Duration(seconds: 30),
  }) async* {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 停止定位
  Future<void> stop() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 释放资源
  void dispose() {
    _locationStream.close();
  }
}

class _IOSLocationCallback extends NSObject with BMKLocationManagerDelegate {}

class _AndroidLocationCallback extends java_lang_Object
    with com_baidu_location_BDLocationListener {
  _AndroidLocationCallback({this.onLocation});

  ValueChanged<com_baidu_location_BDLocation> onLocation;

  @override
  Future<void> onReceiveLocation(com_baidu_location_BDLocation var1) async {
    super.onReceiveLocation(var1);
    if (onLocation != null) onLocation(var1);
  }
}
